%define	fname	SDL
%define	name	SDL12
%define	version	1.2.12
%define rel	1
%define	lib_name_orig	lib%{fname}
%define	lib_major	1.2
%define	lib_name	%mklibname %{fname} %{lib_major}

%if %{mdkversion} >= 1010
%define build_plugins	0
%define build_directfb	1
%define build_ggi	1
%define	build_aalib	1
%else
%define build_plugins	0
%define build_directfb	0
%define build_ggi	0
%define	build_aalib	0
%endif

Summary:	Simple DirectMedia Layer
Name:		%{name}
Version:	%{version}
Release:	%mkrel %{rel}
Source0:	http://www.libsdl.org/release/%{fname}-%{version}.tar.gz
Patch0:		SDL-1.2.10-fixrpath.patch
Patch1:		SDL-1.2.10-libtool.patch
Patch2:		SDL-1.2.10-workaround-absence-of-usrlib-in-esdconfig-libs.patch
Patch3:		SDL-1.2.10-fix-libtoolize.patch
#Patch3:		SDL-1.2.8-x86_64.patch.bz2
#gw from CVS: fix build with alsa 1.0
#Patch4:		SDL-1.2.9-directfb.patch.bz2
#Patch7:		SDL-1.2.6-new-alsa.patch.bz2
# (gb): handle some video drivers as a plugin
#Patch10:	SDL-1.2.7-video-plugins.patch.bz2
#Patch20:	SDL-1.2.8-gcc4.patch.bz2
Patch21:	SDL-1.2.10-anonymous-enums.patch
#Patch22:	SDL-1.2.9-gcc4-fix.patch.bz2
#(peroyvind): debian patches
#Patch30:	SDL-1.2.9-x11-keysym-fix.patch.bz2
Patch31:	SDL-1.2.10-lock-keys.patch
#Patch32:	SDL-1.2.9-aalib-keys.patch.bz2
#Patch33:	SDL-1.2.10-alsa-priority.patch.bz2
#Patch34:	SDL-1.2.9-bad-blit-test.patch.bz2
Patch35:	SDL-1.2.10-mprotect.patch
#Patch36:	SDL-1.2.9-gnu-stack.patch.bz2
#Patch37:	SDL-1.2.10-hermes-pic-support.patch.bz2
Patch38:	SDL-1.2.9-missing-mmx-blit.patch
Patch39:	SDL-1.2.10-propagate-pic-to-nasm.patch
#Patch40:	SDL-1.2.10-autogen-autotools.patch.bz2
Patch41:	SDL-1.2.10-nasm-include.patch
#Patch42:	SDL-1.2.8-ppc-vidmode.patch.bz2
#Patch43:	SDL-1.2.10-relibtoolize.patch.bz2
Patch44:	SDL-1.2.10-fix-nas-detection.patch
Patch50:	SDL-1.2.10-byteorder.patch
Patch51:	SDL-1.2.12-preferalsa.patch
Patch52:	SDL-1.2.12-pagesize.patch
Patch53:	SDL-1.2.11-no-yasm.patch
Patch54:	SDL-1.2.11-dont-propagate-lpthread.patch
Patch55:	SDL-1.2.11-supermount-double-free-issue.patch
License:	LGPL
Group:		System/Libraries
URL:		http://www.libsdl.org/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires:	arts-devel
BuildRequires:	automake1.9
# libGL is required to enable glx support
BuildRequires:	libmesaglu-devel
BuildRequires:	esound-devel
BuildRequires:	nas-devel
BuildRequires:	chrpath
%ifarch %{ix86}
BuildRequires:	nasm
%endif
%if %{build_plugins}
BuildRequires:	libtool-devel
%endif
%if %{build_directfb}
BuildRequires:	DirectFB-devel >= 1.0.0
%endif
%if %{build_ggi}
BuildRequires:	libggi-devel
%endif
%if %{build_aalib}
BuildRequires:	aalib-devel
%endif

%description
This is the Simple DirectMedia Layer, a generic API that provides low level
access to audio, keyboard, mouse, and display framebuffer across multiple
platforms.

%package -n	%{lib_name}-video-ggi
Summary:	GGI video support for SDL
Group:		System/Libraries
Requires:	%{lib_name} = %{version}-%{release}

%description -n	%{lib_name}-video-ggi
This is the Simple DirectMedia Layer, a generic API that provides low level
access to audio, keyboard, mouse, and display framebuffer across multiple
platforms.

This package provides GGI video support as a plugin to SDL.

%package -n	%{lib_name}-video-directfb
Summary:	DirectFB video support for SDL
Group:		System/Libraries
Requires:	%{lib_name} = %{version}-%{release}

%description -n	%{lib_name}-video-directfb
This is the Simple DirectMedia Layer, a generic API that provides low level
access to audio, keyboard, mouse, and display framebuffer across multiple
platforms.

This package provides DirectFB video support as a plugin to SDL.

%package -n	%{lib_name}
Summary:	Main library for %{name}
Group:		System/Libraries
Provides:	%{name} = %{version}-%{release}
Provides:	%{lib_name_orig} = %{version}-%{release}
Obsoletes:	SDL
Provides:	SDL

%description -n	%{lib_name}
This package contains the library needed to run programs dynamically
linked with %{name}.

%package -n	%{lib_name}-devel
Summary:	Headers for developing programs that will use %{name}
Group:		Development/C
Requires:	%{lib_name} = %{version} libalsa-devel >= 0.9.0
Provides:	%{lib_name_orig}-devel = %{version}-%{release}
Provides:	SDL-devel, SDL%{lib_major}-devel
Obsoletes:	SDL-devel

%description -n	%{lib_name}-devel
This package contains the headers that programmers will need to develop
applications which will use %{name}.

%prep
%setup -q -n %{fname}-%{version}
%patch0 -p1
%patch1 -p1 -b .libtool
%patch2 -p1
#%patch3 -p1 -b .x86_64
#%patch4 -p1 -b .directfb
#%patch7 -p1
#%patch8 -p1 -b .joystick
#%patch9 -p1 -b .gcc3.4
#%patch10 -p1 -b .video-plugins
#%patch20 -p1 -b .gcc4
%patch21 -p1 -b .enums
#%patch22 -p1 -b .gcc4-2
#%patch30 -p1 -b .keysym
%patch31 -p1 -b .lock
#%patch32 -p1 -b .aalib
#%patch33 -p1 -b .alsa
#%patch34 -p1 -b .bad_blit
%patch35 -p1 -b .mprotect
#%patch36 -p1 -b .gnu_stack
#%patch37 -p1 -b .hermes_pic
%patch38 -p1 -b .mmx_blit
%patch39 -p1 -b .nasm_pic
#%patch40 -p1 -b .autogen
%patch41 -p1 -b .nasm_include
#%patch42 -p1 -b .ppc_vidmode
#%patch43 -p1 -b .relibtoolize
#patch44 -p1 -b .nas_detection
%patch50 -p1 -b .byteorder
%patch51 -p1 -b .alsa
%patch52 -p1 -b .pagesize
%patch3 -p1 -b .libtoolize
#patch53 -p1 -b .no_yasm
%patch54 -p1 -b .no_lpthread
#patch55 -p0 -b .supermount

%build
export CFLAGS="$RPM_OPT_FLAGS -fPIC -O3"
export CXXFLAGS="$RPM_OPT_FLAGS -fPIC -O3"
#export CPPFLAGS=-I/usr/X11R6/include
# (gb) Look for ESD libraries in the right directories, avoid patch
# FIXME: Better go to the same way as for CheckARTSC
perl -pi -e "s|/usr/lib/|%{_libdir}/| if /(esd|arts)_lib_spec=/" configure
%configure2_5x	--enable-video-opengl \
		--disable-video-svga \
%if %{build_ggi}
		--enable-video-ggi \
%if %{build_plugins}
		--enable-video-ggi-plugin \
%endif
%endif
%if %{build_directfb}
		--enable-video-directfb \
%if %{build_plugins}
		--enable-video-directfb-plugin \
%endif
%endif
%if %{build_aalib}
		--enable-video-aalib \
%if %{build_plugins}
		--enable-video-aalib-plugin \
%endif
%endif
		--disable-debug \
		--enable-dlopen \
		--enable-sdl-dlopen \
		--enable-arts \
		--enable-arts-shared \
		--enable-esd \
		--enable-esd-shared \
		--enable-nas \
		--program-prefix= \
		--disable-rpath
%make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall

# remove unpackaged files
%if %{build_plugins}
rm -f $RPM_BUILD_ROOT%{_libdir}/SDL/*.a
%endif

# --disable-rpath does not seem to work correctly
chrpath -d %{buildroot}%{_libdir}/libSDL.so

#multiarch
%multiarch_binaries $RPM_BUILD_ROOT%{_bindir}/sdl-config

%post -n %{lib_name} -p /sbin/ldconfig
%postun -n %{lib_name} -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files -n %{lib_name}
%defattr(-,root,root)
%doc README-SDL.txt COPYING CREDITS BUGS
%{_libdir}/libSDL-%{lib_major}.so.*
%if %{build_plugins}
%dir %{_libdir}/SDL
%endif

%if %{build_plugins}
%if %{build_ggi}
%files -n %{lib_name}-video-ggi
%defattr(-,root,root)
%{_libdir}/SDL/video_ggi.*
%endif

%if %{build_directfb}
%files -n %{lib_name}-video-directfb
%defattr(-,root,root)
%{_libdir}/SDL/video_directfb.*
%endif
%endif

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc README README-SDL.txt COPYING CREDITS BUGS WhatsNew docs.html
%doc docs/html/*.html
%{_bindir}/sdl-config
%multiarch %{multiarch_bindir}/sdl-config
%{_libdir}/pkgconfig/sdl.pc
%{_libdir}/*a
%{_libdir}/*.so
%dir %{_includedir}/SDL
%{_includedir}/SDL/*.h
%{_datadir}/aclocal/*
%{_mandir}/*/*




%changelog
* Thu Jul 26 2007 Funda Wang <fundawang@mandriva.org> 1.2.12-1mdv2008.0
+ Revision: 55747
- Redif patch51, patch52
- New version

* Mon May 21 2007 Funda Wang <fundawang@mandriva.org> 1.2.11-8mdv2008.0
+ Revision: 29100
- Rebuuild against directfb 1.0.0


* Sun Feb 18 2007 Anssi Hannula <anssi@mandriva.org> 1.2.11-7mdv2007.0
+ Revision: 122613
- ggi and directfb can now be enabled again

* Sun Feb 18 2007 Anssi Hannula <anssi@mandriva.org> 1.2.11-6mdv2007.1
+ Revision: 122548
- build without directfb and ggi until they will be rebuilt
- rebuild for new libgii
- buildrequire chrpath for rpath removal
- disable rpath
- add missing buildrequires

  + Olivier Blin <oblin@mandriva.com>
    - Import SDL12

* Tue Aug 22 2006 Guillaume Bedot <littletux@mandriva.org> 1.2.11-3mdv2007.0
- fix for #24005

* Wed Jul 26 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.2.11-2
- add BuildRequires: libmesaglu-devel

* Sat Jul 22 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.2.11-1mdv2007.0
- 1.2.11
- use nasm, not yasm as it will fail to build (P53 from debian)
- Do not propagate -lpthread to sdl-config --libs (P54 from debian)
- Removed ugly stuff from acinclude.m4 (P55 from debian)
- drop P37 (merged upstream)
- fix macro-in-%%changelog

* Sun Jun 25 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.2.10-1mdv2007.0
- New release 1.2.10
- enable aalib support
- regenerate P0, P1, P2, P21, P31,
- sync P35, P37, P39, P40 with debian	
- drop P4, P7, P10, P22, P30, P32, P34, P36 & P41 (fixed upstream)
- fix nas detection (P44 from debian)
- fix problem with little/big endian (P50 from fedora)
- prefer alsa, arts and esd too before oss (P51 from fedora)
- new pagesize patch (drop PAGE_SIZE, use sysconf(_SC_PAGESIZE) instead (P52 from fedora)

* Thu May 11 2006 Götz Waschk <waschk@mandriva.org> 1.2.9-5mdk
- update patch 4 for new SDL

* Thu Apr 20 2006 Stefan van der Eijk <stefan@eijk.nu> 1.2.9-4mdk
- BuildRequires:	automake1.8

* Wed Apr 19 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.2.9-3mdk
- remove redundant requires (fixes #22048)
- patches from our nice friends @ debian (with debian bugzilla references):
	o Patch courtesy of Jochen Voss to fix lookup of keys using eg. the
	  AltGr modifier (Closes: #299864) (P30)
	o Patch courtesy of Bas Wijnen to generate release events for lock keys
	  (Caps Lock and Num Lock) just like normal keys (Closes: #317010). (P31)
	o Arrow keys and the numeric keypad conflict in the aalib driver, make the
	  former take precedence (Closes: #170548). (P32)
	o Fix a crash when aa_getevent returns a scancode value bigger than 400. (P32)
	o When both are available, try the ALSA output driver before the OSS one. (P33)
	o New patch: "dst_w == last.src_w" should be "dst_w == last.dst_w" in
	  src/video/SDL_stretch.c. (P34)
	o SDL_stretch.c: use mprotect() on the pages storing dynamically generated
	  code so that we still work on systems that enforce W^X. (P35)
	o Add ".note.GNU-stack" sections to all NASM files so that gcc does not
	  think these files need an executable stack. (P36)
	o Add PIC support to the Hermes assembly files, one step closer to a fully
	  PIC compliant libSDL. (P37)
	o New patch: ConvertMMXpII32_24RGB888 was not used anywhere, yet it is
	  fully functional. This patch activates it. (P38)
	o Do not strip -DPIC from the NASM compilation flags. They are useful. (P39)
	o Improved cleaning up in autogen.sh and activated AM_MAINTAINER_MODE. (P40)
	o New patch: add -I$(srcdir)/ to the NASM flags so that we can include
	  common files. (P41)
	o Fixed PPC fullscreen vidmode problem (Closes: 285729). (P42)

* Wed Nov 09 2005 Götz Waschk <waschk@mandriva.org> 1.2.9-2mdk
- patch for new DirectFB

* Sun Oct 09 2005 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.2.9-1mdk
- 1.2.9
- drop x86_64 patch (P3, merged upstream)
- fix build with gcc 4 (P22 from SDL CVS)
- clean out old junk from %%build
- %%mkrel

* Tue Aug 16 2005 Götz Waschk <waschk@mandriva.org> 1.2.8-5mdk
- Rebuild

* Mon Aug 01 2005 Guillaume Bedot <littletux@mandriva.org> 1.2.8-4mdk
- rebuild
- Patch20: allows build with gcc4 (from fedora)
- Patch21: should fix anonymous enum problem with armagetron. (from debian)

* Thu Feb 10 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.2.8-3mdk
- libtool fixes to nuke lib64 rpaths
- fix build on x86_64, drop rdtsc() part which is obsolete

* Tue Feb 01 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.8-2mdk
- multiarch
- compile with -O3

* Tue Dec 21 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.8-1mdk
- 1.2.8
- regenerate P2 & P3
- drop P8 & P9 (fixed upstream)

* Wed Sep 29 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.2.7-9mdk
- forgot to regenerate a fixed patch

* Wed Sep 29 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.2.7-8mdk
- build ggi and directfb support as a plugin on MDK >= 10.1

* Wed Sep 01 2004 Götz Waschk <waschk@linux-mandrake.com> 1.2.7-7mdk
- update patch 9 from SDL cvs

* Fri Jul 30 2004 Giuseppe Ghibò <ghibo@mandrakesoft.com> 1.2.7-6mdk
- Merged Gwenole 64bit fixes from 1.2.7-2.1mdk: cputoolize.

* Sat Jun 12 2004 Götz Waschk <waschk@linux-mandrake.com> 1.2.7-5mdk
- patch to make it build with gcc 3.4

* Mon Apr 19 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.7-4mdk
- fix joystick bug (P8, fixes #9432)

* Fri Apr 16 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.7-3mdk
- enable directfb and ggi support

* Tue Mar 02 2004 Götz Waschk <waschk@linux-mandrake.com> 1.2.7-2mdk
- fix buildrequires

* Thu Feb 26 2004 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.7-1mdk
- new version (fix for #8371 at least) (debian and CVS stuff added by
  Per Oyvind merged upstream)

